package cn.dankal.drama;

import android.animation.Animator;
import android.animation.AnimatorListenerAdapter;
import android.animation.ObjectAnimator;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.LinearLayout;

import cn.dankal.drama.widget.StatusBarUtil;


public class SplashActivity extends AppCompatActivity {
    private static final long ANIMATOR_DURATION = 2000;

    LinearLayout mLlRoot;
    ImageView ivSplashImage;

    /**
     * 开始执行透明度渐变动画
     */
    private void initWelcomeAlphaAnimator() {
        // 创建属性动画
        ObjectAnimator objectAnimator = ObjectAnimator.ofFloat(mLlRoot, "alpha", 0.2f, 1.0f);
        // 设置动画时间
        objectAnimator.setDuration(ANIMATOR_DURATION);
        //启动动画
        objectAnimator.start();

        // 设置动画执行监听 -- 适配器模式
        objectAnimator.addListener(new AnimatorListenerAdapter() {

            @Override
            public void onAnimationEnd(Animator animation) {
                startActivity(new Intent(SplashActivity.this, Certifica.class));
                finish();
            }
        });
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_splash);

        //根据状态栏颜色来决定状态栏文字用黑色还是白色
        StatusBarUtil.setStatusBarMode(this, true, R.color.black);

        mLlRoot = findViewById(R.id.ll_welcome_root);
        ivSplashImage = findViewById(R.id.iv_splash_image);
        initWelcomeAlphaAnimator();
    }

}
